Introduction

ApplicationIQ est bénéfique à la fois pour :
  • les développeurs, en facilitant leur travail par l’utilisation d'un référentiel commun adapté à l’entreprise et basé sur le standard UML. La compréhension des éléments de projets, leur réutilisation et la communication générale portant sur les projets sont facilitées.
  • l’entreprise, en capitalisant le savoir-faire contenu dans les projets (structuration commune, aide au portage de projets, aide à la rétro-ingénierie, …) pour pouvoir ensuite réutiliser cette connaissance de manière optimale (phase de découverte des projets facilitée et plus rapide).
ApplicationIQ s’appuie sur le standard UML par l’intermédiaire du modeleur Enterprise Architect (EA) de Sparx Systems.


Editions de ApplicationIQ

ApplicationIQ existe en trois éditions qui sont :

  • l'édition Process-Maker, qui permet de :
    • Définir simplement (en langage naturel) le processus de développement de l’entreprise et les règles de modélisation.
    • Définir les modes de navigation. Ces modes de navigation permettront ensuite de consulter tous les éléments d’un projet de manière transversale en suivant le processus de développement de l’entreprise. Typiquement, un Mode de navigation permet :
      • de « remonter » instantanément d’une classe de conception aux cas d’utilisation amont,
      • de consulter un document d’exigences, puis de « descendre » instantanément aux cas d’utilisation concernés par cette exigence, puis descendre encore aux classes de conception et au code. La compréhension des projets en est rendue optimale.
  • l'édition Designer, qui permet de :
    • modifier votre modèle UML pour l’intégrer au processus de développement. Pour cela, ApplicationIQ contient deux outils puissants de stéréotypage par critères de sélection :
      • un outil pour stéréotyper des ensembles d'entités,
      • un outil pour stéréotyper des ensembles de relations.
    • parcourir tout projet de manière transversale. En particulier, un analyste ou un développeur peuvent consulter facilement tous les éléments constituant le sous-ensemble d’un projet qui le concerne : documentation des exigences, cas d’utilisation, classes connexes, …
    • faire un audit du modèle UML d’un projet et vérifier s’il est conforme aux règles du processus choisi par l’entreprise et à défaut de lister les anomalies.
    • visualiser la complétude d’un projet de rétro-ingénierie. ApplicationIQ permet d’identifier les artefacts qui n’aboutissent pas à du code. Inversement, ApplicationIQ permet d’identifier des classes (donc du code) qui n’est relié à aucun élément d’analyse, aucun cas d’utilisation ou aucun document d’exigences.
  • l'édition Manager, qui contient à la fois l’édition Process-Maker et l’édition Designer.


Installation

Installation de ApplicationIQ

ApplicationIQ s’appuie sur le modeleur UML Enterprise Architect (EA) de Sparx Systems ©.

Vous devez donc posséder une licence de EA pour pouvoir utiliser ApplicationIQ.

Toutefois, la version EA Lite (gratuite) est suffisante si vous n’avez pas besoin de modifier votre modèle UML.

Pour la période d’évaluation de ApplicationIQ, vous pouvez utiliser la version d'évaluation de EA.

En utilisation normale, la version Desktop de EA peut être suffisante pour fonctionner avec ApplicationIQ. Toutefois, selon vos besoins en modélisation, d'autres versions de EA (par exemple Professional ou Corporate) peuvent être plus adaptées.


Choix de la langue

ApplicationIQ fonctionne en anglais et en français.

Pour changer de langue, il est nécessaire de sélectionner le menu « Outils », puis « Paramètres ». Dans la boîte de dialogue qui s’affiche, vous pouvez alors choisir la nouvelle langue et cliquer sur « Fermer ».

Vous devez redémarrer ApplicationIQ pour que le changement prenne effet.


Activation de ApplicationIQ

Après avoir acheté la version commerciale de ApplicationIQ, vous recevrez un lien pour télécharger la version commerciale du programme.

Vous devez alors désinstaller la version d’évaluation, puis installer la version commerciale.

Après avoir installé la version commerciale, vous avez dix jours pour activer le logiciel.

Pour activer le logiciel, vous devez générer un fichier Flag, l’envoyer avec les références de votre commande à l’adresse : commercial@Application-IQ.com. En retour, vous recevrez sous 24 heures environ, un fichier Licence que vous devrez insérer.


Générer fichier Flag

Générer un fichier Flag

Pour générer un fichier Flag, vous devez cliquer sur le menu « Outils », puis « Licence », puis « Générer un fichier Flag ».

Une boîte de dialogue s’affiche.

Vous devez alors saisir l’emplacement où vous voulez enregistrer le fichier Flag puis cliquer sur le bouton « Générer ».


Insérer un fichier de Licence

Pour insérer un fichier de Licence, vous devez :

  • cliquer sur le menu « Outils »,
  • puis cliquer sur « Licence »,
  • puis cliquer sur « Insérer un fichier Licence ».

Une boîte de dialogue s’affiche.

Vous devez alors saisir l’emplacement où se trouve le fichier Licence et cliquer sur le bouton « Insérer ».


Transfert de la licence sur un autre ordinateur

Après avoir insérer le fichier Licence, vous avez la possibilité de transférer cette licence depuis cet ordinateur (Origine) vers un autre ordinateur (Cible).

Important : Vous devez préalablement avoir installé la version commerciale de ApplicationIQ sur l'ordinateur cible.

Pour transférer la licence sur l'ordinateur Cible, vous devez :

1. Générer un fichier Flag à partir de l’ordinateur Cible.

2. Sur l'ordinateur Origine, vous devez sélectionner au menu « Outils », puis « Licence », puis « Transférer la licence vers un autre PC ». Une boîte de dialogue s’affiche. Elle vous permet d’insérer le fichier Flag et spécifier l’emplacement où sera enregistré le fichier de licence (qui sera inséré ensuite dans l’ordinateur Cible).

Important : Après la génération du fichier Licence, ApplicationIQ n’est plus accessible sur l’ordinateur Origine.

3. Sur l’ordinateur Cible, vous devez alors insérer le fichier Licence en activant le menu « Outils », « Licence », « Insérer un fichier Licence ».

Suite à ces opérations, ApplicationIQ est :
  • Inactif sur l'ordinateur Origine
  • Actif sur l'ordinateur Cible.


Aide et support

Support par mail à l'adresse : support@Application-IQ.com


Présentation

  • Bénéfices clés
  • Ce que vous pouvez faire ...
  • Fonctions clé


Bénéfices clés

  • Capitalisation du savoir-faire intégré aux projets et qui est immuable, en le spécifiant de manière indépendante des plateformes et des langages.
  • Pérennisation des investissements logiciels en adaptant uniquement les phases du processus qui doivent changer. Par exemple, dans le cas d’un portage, il n'est pas nécessaire de modifier tout le travail effectué dans les phases amont, jusqu’à la phase de Conception PSM « Plateform Specific Model ».
  • Exploitation d’une structure commune à tous vos projets (de la documentation jusqu'au code source) pour plus d’efficacité pour vos équipes de développement.
  • Création réelle du patrimoine applicatif de l'entreprise.
  • Facilitation de la mise en route et de la maîtrise de vos projets.
  • Maintenance de vos projets facilitée.
  • Uniformisation du format de communication de vos projets, pour un gain en efficacité, évolutivité, maintenabilité, …


Ce que vous pouvez faire

  • Exploiter facilement les principes de MDA (…) et MDE (…)
  • Adapter vos projets actuels vers MDA ou MDE
  • Faire de la rétro-ingénierie en sachant « par quel bout » prendre le problème
  • Faire du portage d’une plateforme à une autre (Ex : Windows vers Cloud)
  • Faire des analyses d’impacts très simplement
  • ... et bien plus, selon votre imagination


Fonctions clés

  • Spécification :
    • Spécification du processus de développement
    • Spécification des règles de modélisation
    • Spécification des modes de navigation

  • Exploitation :
    • Navigation classique :
      • transversale vers l’avant (depuis les artefacts d’une activité vers les artefacts d’une autre activité connexe en aval), par exemple depuis les exigences vers les classes d’implémentation (sources).
      • transversale vers l’arrière (depuis les artefacts d’une activité vers les artefacts d’une autre activité connexe en amont), par exemple depuis les classes d’implémentation (sources) vers les exigences.

    • Navigation « de complétude » : très efficace et utile dans les projets de rétro-ingénierie, rétro-documentation, …
      • Vers l’avant, par exemple pour répondre à des questions du type « Quels sont les cas d’utilisation qui n’aboutissent que partiellement à une implémentation (ce qui revient à identifier les cas d’utilisation qui n'ont été que partiellement développés) ?» ; « Quels sont les artefacts qui ne sont suivis d’aucune entité dans les activités suivantes ? (ce qui signifie, qu’ils ne sont pas développés) », …
      • Vers l’arrière, par exemple pour répondre à la question « Quelles sont les classes qui ne sont rattachées à aucune exigence ? » (ce qui signifie qu’ils ne sont pas documentés), « Quels sont les composants qui ne sont que partiellement documentés dans les exigences », …
    • Outils de stéréotypage de modèle, particulièrement efficaces et utiles en rétro-ingénierie et pour l’intégration d’un projet existant, actuellement indépendant au processus standard de l’entreprise :
      • Outil d’affectation de stéréotypes aux entités
      • Outil d’affectation de stéréotypes aux relations


Pré-requis, à lire avant de démarrer

  • Notation
  • Définitions
  • Principe général


Notation

Un type d’entité stéréotypée est, comme son nom l'indique, un type d'entité UML auquel on a attribué un stéréotype. Il est noté de la manière suivante dans ApplicationIQ : TypeDEntité – « Stéréotype ».

Exemples de types d'entité stéréotypées :
- UseCase - "Besoin Fonctionnel"
- Collaboration - "Conception Java"
- Class - "Conception Java"
- Class - "Conception C#"

Dans la documentation, pour un besoin de clarté, les types d’entités stéréotypées seront entourés de [ ].
Par exemple : [UseCase – « Besoin »].

Ce principe de notation est également utilisé pour les relations et les diagrammes.


Définitions

  • Processus de développement
  • Activité
  • Entité
  • Diagrammes
  • Relations
  • Règles


Processus de développement

Un processus de développement est une suite d’activités comprenant une activité de début (par exemple les exigences du projet) et une activité de fin (par exemple les classes d’implémentation du projet).
Certaines activités peuvent se dérouler en parallèle comme les activités de développement liées à des plateformes différentes.

Exemples :
  • Activité de développement d’une IHM en C# parallèle à l’activité de développement de la même IHM pour le web, avec des composants métiers uniques et utilisés par les deux plateformes.
  • Unified Process comporte les activités :
    • Besoins
    • Analyse
    • Conception
    • Implémentation
    • Tests


Activités

Chaque activité reçoit en entrée des entités issues d’une activité précédente (sauf la première activité du processus) et elle produit des entités qui seront à leur tour en entrée de l’activité suivante (sauf pour la dernière activité).
Une activité peut produire un type d’entité unique ou deux types d’entités reliées. Dans ce cas, l’un des ensembles d’entités sera en amont de l’autre ensemble.
Par exemple :
  • Exemple 1 : 1 Collaboration => n Classes
  • Exemple 2 : n Classes => 1 Composant.


Entités

Les entités sont produites par les activités. Typiquement, une entité peut être « un document d’exigence », « un cas d’utilisation », « une classe », « un composant », « un nœud d’exécution », …
Pour intégrer les entités dans un processus, elles doivent être stéréotypées. Ce stéréotypage peut être établi de manière plus ou moins fine, selon la nécessité de vos projets.
Par exemple :
  • une exigence peut être stéréotypée « Exigence fonctionnelle » ou « Exigence matérielle »,
  • un cas d’utilisation peut être « CU externe » ou « CU interne »,
  • une classe peut être « PIM » (Plateform Independant Model) ou « PSM_C# » (Plateform Specific Model) ou « PSM_Java » …


Diagrammes

Les diagrammes permettent de représenter de manière standard les aspects statiques (par exemples les classes et leurs liens) et dynamiques du projet (les transitions, les interactions, …).
Les diagrammes doivent être stéréotypés en fonction de leur sémantique pour être intégrées au processus géré par ApplicationIQ.


Relations

Ce sont les liens qui relient les entités entre elles.
Les relations doivent être stéréotypées en fonction de leur sémantique.
Par exemple : « Traçabilité de Cas d’utilisation à Classe d’analyse ».


Règles

Les règles permettent d’auditer un modèle en un instant et vérifier ainsi s’il est conforme au processus choisi par l’entreprise.

Il existe quatre catégories de règles :
    • Règles d’Entités – Propriétés :
Elles permettent de définir quels sont les types d’entités (stéréotypées) qui doivent contenir de la documentation et sous quelle forme (note, linked file, fichier libre lié).

    • Règles d’Entités – Relations :
Elles permettent de définir très finement les obligations de relation entre types d’entités.
Exemple :
Tous les [Requirements - « Exigence »] doivent être reliés à au moins une entité du type [UseCase - « Besoin »], par une relation du type : [Abstraction - « Besoin à Exigence »].
Remarque : Cet exemple définit une règle de traçabilité entre Requirements et Cas d’utilisation.

    • Règles d’Entités – Diagrammes :
Elles permettent d’imposer aux entités de certains types de figurer dans certains types de diagrammes.
Exemple :
Toutes les entités du type [Requirement – « Exigence »] doivent apparaître dans au moins un diagramme du type [Custom - « Exigences »].

    • Règles de Relations :
Elles permettent de définir quels sont les types d’entités que doivent relier les types de relation. Elles définissent la finalité des relations stéréotypées.
Exemple :
Toutes les relations [Abstraction – « Besoin à Exigence »] doivent relier des [UseCase – « Besoin »] à des [Requirement – « Exigence »].


Principe général

1. La phase de « Spécification »

2. La phase d’ « Exploitation »


La phase de spécification

La phase de « Spécification »

Elle permet de formaliser le processus de développement par :
  • la définition des stéréotypes :
    • de chaque type d’entité
    • de chaque type de relation
    • de chaque type de diagramme
  • la définition de chaque activité avec :
    • les types d’entités stéréotypés produits
    • les types d’entités stéréotypés en entrée, reliés par un type de relation stéréotypé au type d’entités produits
    • la définition des règles méthodologiques que doivent respecter vos modèles.

Les entités, les relations et les diagrammes du modèle du projet doivent être stéréotypés. ApplicationIQ comporte des outils permettant de le faire de manière très efficace. C’est par ce stéréotypage que le modèle sera intégré au processus. A partir du moment où le stéréotypage est effectué, ApplicationIQ (Exploitation) permet différentes utilisations qui apportent pérennité, capitalisation, …

  • En mode « Standard » :
    • Cibler un aspect du projet et naviguer de manière transversale pour mieux appréhender son contexte et son fonctionnement.
    • Effectuer des analyses d’impact de manière interactive vers l’avant, vers l’arrière et dans les deux sens.
    • Différencier les composantes stables dans un but de capitalisation
    • …

  • En mode « Complétude » :

ApplicationIQ permet de visualiser les entités dont toutes les « branches » n’aboutissent pas à la dernière activité, ce qui signifie par exemple, que des cas d’utilisation ne sont pas complètement implémentés. En mode « backward », on pourra détecter que des classes ne sont pas reliées à des exigences, c'est-à-dire une rétro-documentation incomplète ou un projet qui n’a été que partiellement documenté.

Exemples de processus :
    • Requirements => Cas d’utilisation => Classes de conception C#
    • Requirements => Cas d’utilisation => Classes de conception => Classes de tests
    • Requirements => Cas d’utilisation => Classes de conception PIM => Classes de conception Java
    • Requirements => Cas d’utilisation => Classes de conception Windows (Serveur)
Cas d’utilisation => Classes de conception Java


La phase d'exploitation

La phase d' « Exploitation »

Elle permet de :

  • Auditer un modèle pour vérifier s’il est conforme au processus de développement qui a été défini en phase de « Spécification ».
  • Explorer votre projet d’activité en activité vers l’aval, par exemple en suivant la traçabilité d’un document d’exigences, en passant par les différentes activités pour arriver aux classes d’implémentation.
  • Explorer votre projet vers l’amont, par exemple en suivant la traçabilité d’une classe d’implémentation d’activité en activité pour remonter jusqu’aux cas d’utilisation ou aux exigences.
  • Vérifier la complétude de votre projet de rétro-documentation par un parcourt en mode « Complétude » vers l’amont.
  • Vérifier le degré de finalisation d’un projet par un parcours en mode « Complétude » vers l’aval.
  • Consulter le niveau de complétude d’un projet de rétro-ingénierie.
  • Consulter le niveau de complétude d’un projet de portage.
  • …


Démarrage rapide

Comment faire pour :

  • spécifier un processus de développement
  • exploiter un projet
  • faire une navigation "standard"
  • faire une navigation de "complétude"
  • intégrer un modèle existant au processus de l'entreprise
  • intégrer un projet dont on ne possède que le code source
  • gérer un projet de portage
  • effectuer l'audit d'un modèle


Spécifier un processus de développement

Pour spécifier un processus de développement, vous devez :
  • Déclarer les stéréotypes
    • Stéréotypes d’entité,
    • Stéréotypes de relations,
    • Stéréotypes de diagrammes
  • Affecter un stéréotype aux types
    • Types d’entités,
    • Types de relations,
    • Types de diagrammes
  • Déclarer les activités de votre processus
  • Déclarer les liens entre activités, c'est-à-dire déclarer les types d’entités stéréotypés des activités sources qui alimentent une activité et les types d’entités stéréotypées que cette activité produit.
  • Définir les règles du processus de développement portant sur :
    • les entités (propriétés, relations avec les autres entités)
    • les diagrammes,
    • les relations,
  • Définir les modes de navigation qui permettront ensuite, en exploitation, de :
    • visualiser le projet de manière transversale (vers l’avant, vers l’arrière et dans les deux sens), avec un affichage en un click des diagrammes associés aux entités visualisées.
    • effectuer une lecture du niveau de complétude du projet vers l’avant (vers l’implémentation), vers l’arrière (vers les exigences) dans le but d’estimer sa « dette technique » éventuelle à toutes les étapes du processus.


Exploiter les projets

Après avoir créé un processus (Spécification), défini les règles et les modes de navigation, il est nécessaire de valider l’ensemble des spécifications pour passer en « Exploitation ».


Faire une navigation Standard

Faire une navigation « Standard »

Ce type de navigation est particulièrement utile dans le cas de découverte d’un projet existant, pour effectuer des analyses d’impacts, …

Vous devez :
  • être en « Exploitation »,
  • avoir chargé le modèle que vous souhaitez consulter,
  • choisir un Mode de navigation (ou conserver celui qui est déjà sélectionné),
  • choisir le Type de navigation « Standard » (il est sélectionné par défaut),
Vous pouvez alors effectuer une consultation :
  • vers l’aval en cliquant sur le libellé en entête de la première activité
  • vers l’amont en cliquant sur le libellé en entête de la dernière activité
  • vers l’amont et vers l’aval si vous cliquez sur le libellé en entête d’une activité interne (ni la première, ni la dernière) au processus.
Dans les trois cas, vous pouvez sélectionner les entités de l’activité qui vous intéressent, afficher tous les diagrammes UML qui contiennent ces entités et parcourir de proche en proche toutes les entités des activités précédentes et suivantes à celle que vous avez sélectionnée.
Tous les types d’entité UML sont pris en compte dans la navigation (Requirement, UseCase, Class, …). Si l’entité contient une documentation textuelle (note, linked document ou fichier associé), celle-ci peut aussi être affichée par un click droit.


Faire une navigation de "Complétude"

(par exemple pour estimer l'importance une dette technique)

Ce type de navigation est particulièrement utile dans les projets de rétro-ingénierie, de portage d’application, de suivi de réalisation, ...

Vous devez :
  • être en « Exploitation »,
  • avoir chargé le modèle que vous souhaitez consulter,
  • choisir un Mode de navigation (ou conserver celui qui est présenté par défaut),
  • choisir le Type de navigation « Complétude »,
  • vous pouvez alors effectuer une consultation :
    • vers l’aval en cliquant sur le libellé en entête de la première activité du processus
    • vers l’amont en cliquant sur le libellé en entête de la dernière activité du processus.
Vous pouvez alors sélectionner les entités qui vous intéressent, ApplicationIQ mets en évidence les entités suivantes …
Comme pour le type de navigation « Standard », vous pouvez afficher tous les diagrammes contenant l’entité sélectionnée et les documentations associées aux entités.


Intégrer un modèle existant au processus et à la méthodologie de l'entreprise

Pour intégrer un modèle existant dans un processus, vous devez affecter aux entités, relations et diagrammes du modèle à intégrer les stéréotypes de votre processus.

ApplicationIQ possède deux outils très efficaces pour affecter des stéréotypes à un ensemble d’entités et à un ensemble de relations.

Ces fonctionnalités sont accessibles quand vous êtes en « Exploitation », c'est-à-dire quand le processus est validé et le modèle chargé.


Intégrer un projet dont vous ne possédez que le code source

Exemple numéro 1 d’intégration :
  • Vous devez tout d’abord effectuer une rétro-ingénierie du projet avec Enterprise Architect ©. Le langage de développement de votre projet doit être parmi les dix langages (en version 12) supportés par Enterprise Architect et qui sont : ActionScript, C, C#, C++, Delphi, Java, PHP, Python, Visual Basic, VB.Net. Si votre langage ne fait pas partie de cette liste, un autre exemple plus loin illustre une autre démarche.
  • Une fois que votre code source est traduit en modèle UML, vous pouvez charger ce modèle UML dans ApplicationIQ. La dernière activité du processus contiendra alors les classes du projet liées à la plateforme cible.
  • Votre modèle devra être « travaillé » afin d’organiser les éléments du projet, par exemple en regroupant dans des diagrammes de classes et des packages les classes qui collaborent pour implémenter une fonctionnalité, …
  • Ces fonctionnalités permettront ensuite de définir des cas d’utilisation.

Ceci est un exemple de démarche à suivre. Bien sûr, la nature du projet peut nécessiter une démarche différente, comme partir des deux extrémités du processus : les cas d’utilisation d’un côté et les classes d’implémentation de l’autre comme dans l’exemple numéro 2 ci-après.

Exemple numéro 2 d’intégration :
Vous pouvez effectuer une démarche double (ascendante et descendante) :
  • Rédiger les exigences à partir de l’exécutable,
  • Effectuer une rétro-ingénierie du projet telle que décrite précédemment,
  • Progresser à la fois :
    • Depuis les exigences jusqu’aux classes PSM, en progressant vers l’aval,
    • Depuis les classes PSM jusqu’aux exigences, en progressant vers l’amont.


Projet de portage

C'est à dire intégrer à votre processus de développement un projet dont vous possédez la documentation technique et un exécutable ou dont le code source est dans un langage non supporté par Enterprise Architect ©.

Exemple de démarche à suivre :
  • A partir de l’exécutable, définir le graphe exhaustif des cas d’utilisation (en exploitant au maximum les relations portant sur les cas d’utilisation : extend, include, …
  • Intégrer la documentation existante, la vérifier et la valider avec les Cas d’utilisations.
  • A partir des Cas d’utilisation, définir un modèle d’analyse ou un modèle PIM (1) ou directement un modèle PSM (2) dans votre langage cible.

(1) PIM = Platform Independend Model
(2) PSM = Platform Specific Model


Effectuer un audit d'un modèle

  • Votre processus de développement doit avoir été spécifié.
  • Votre modèle doit être chargé.
  • Il est alors nécessaire d’aller dans la partie « Exploitation » et cliquer sur le bouton « Audit ». Le résultat de l’audit figure dans la liste au bas de l’écran. Elle peut être copiée dans le presse-papier avec le bouton figurant sous la liste du résultat de l’audit.


Guide de l'utilisateur

1. Généralités sur la saisie

2. Créer un nouveau processus

3. Charger un processus

4. Spécifications

5. Exploitation

6. Outils


Généralités sur la saisie

L’enregistrement des données saisies et des modifications se fait en cliquant sur le bouton « Enregistrer » dans la barre d’icônes (ou au menu « Fichier »).

Dans certaines circonstances, les valeurs affichées ne sont pas modifiables :
  • Quand un processus est validé : Pour pouvoir modifier le processus en cours, il faut retourner en « Modification » en cliquant sur le bouton « Modifier le processus » ou en activant cette fonction au menu. Vous pourrez alors changer les valeurs spécifiant le processus.
  • Quand l’information actuellement à l’écran est utilisée dans au moins l’un des autres écrans de spécification. Cette interdiction existe pour des raisons d’intégrité. Dans ce cas, un symbole de cadenas est affiché. Pour pouvoir modifier les données de l’entité en cours, il est nécessaire de « dé-référencer » cette information (c'est-à-dire ne plus l’utiliser) dans les autres écrans où elle est utilisée.
Remarque : Une astuce consiste à créer un nouvel enregistrement, à modifier les écrans dans lesquels elles sont référencées, puis à supprimer l’ancien enregistrement.

En mode d’utilisation normal (en mode de saisie) :
  • Un click sur une ligne du tableau entraine l’affichage de l’enregistrement dans la zone supérieure de l’écran.
  • Toutes les informations affichées sont modifiables.
  • Une suite de modifications qui remet les zones de saisie dans leur état initial (retour aux valeurs à l’ouverture) permet de sortir de l’écran sans cliquer sur enregistrer.
  • Le changement d’enregistrement en cours de saisie, annule la modification en cours après une demande de confirmation.
  • En cliquant sur le bouton « Nouveau », tous les champs de saisie sont vidés et un nouvel enregistrement est prêt à être saisi.
  • Le bouton « Supprimer » permet de supprimer l’enregistrement actuellement sélectionné et affiché.


Créer un nouveau processus

Deux actions permettent de démarrer la création d’un nouveau processus :

  • Cliquer sur le bouton « Créer un nouveau processus » figurant dans la barre d’icônes.
  • Utiliser le menu « Fichier » et activer le sous-menu « Nouveau processus ». Suite à l’une de ces deux actions, le mode « Spécification » devient accessible, l’onglet de même nom est alors actif. Vous pouvez alors démarrer la saisie de toutes les caractéristiques du processus.
Il est nécessaire de valider le processus pour pouvoir passer dans le mode « Exploitation ».


Charger un processus

Deux actions permettent de charger un processus qui a été préalablement enregistré :

  • Cliquer sur le bouton « Ouvrir un processus » figurant dans la barre d’icônes.
  • Utiliser le menu « Fichier » et cliquer sur le sous-menu « Ouvrir processus ».
Suite à l’une de ces deux actions, une boîte de dialogue de sélection des fichiers est ouverte. Vous pouvez alors parcourir les dossiers et ouvrir le processus que vous aurez désigné. Le mode « Spécification » est alors accessible. Si le processus chargé avait été validé, les informations qu’il contient seront présentées en lecture seule. Si le processus n’a pas été validé lors de la cession précédente, le processus sera modifiable.

Si vous voulez modifier un processus qui a été validé, il est nécessaire :
  • de décharger le modèle en cours (si un modèle a été chargé).
  • activer le bouton « Modifier le processus ». Après les modifications effectuées sur le processus, il sera nécessaire de le valider à nouveau pour pouvoir passer en « Exploitation ».


Onglet "Spécification"

En activant l’onglet « Spécification », vous accédez aux informations qui décrivent le processus de développement. Si le processus est dans l’état « validé », les informations présentées ne seront pas modifiables. Pour pouvoir les modifier, il est nécessaire d’activer la fonction « Modifier le processus ».

Le menu arborescent de gauche permet d’activer chacun des écrans de spécification du processus.

La déclaration des activités est faite indépendamment des modes de navigation (dans l’absolu). Le contrôle de la saisie des modes de navigation s'effectue en fonction de la déclaration des activités que vous aurez saisie préalablement.


Entité

  • Stéréotypes d’entités
Cet écran permet de définir tous les stéréotypes qui seront ensuite affectés aux types d’entités. En phase d’exploitation, ils permettront de différencier les entités d’un même type ayant une finalité différente, par exemple des classes « Conception C# » et des classes « Conception Android ».
  • Type d’entités stéréotypées
Cet écran permet de définir des couples (type d’entité, stéréotype d’entité). Tous les types d’entité UML que vous utilisez dans votre processus doivent être spécialisés avec un ou des stéréotypes d’entités.
    • Ils permettent d’identifier les types d’entité qui font partie du processus,
    • Ils permettent de distinguer des types d’entités produites identiques, mais qui ont une finalité différente, et qui se trouvent dans une même phase du processus (Groupe d’activités). Par exemple : « Conception C# » et « Conception Java ».


Relation

Relation s

  • Stéréotypes de relations
Cet écran permet de définir tous les stéréotypes qui seront ensuite affectés aux types de relations. En phase d’exploitation, ils permettront de différencier les relations d’un même type ayant une finalité différente, par exemple « Traçabilité Analyse-PIM » et « Traçabilité PIM-PSM ».
  • Types de relations stéréotypées
Cet écran permet de définir des couples (type de relation, stéréotype de relation). Tous les types de relation UML que vous utilisez dans votre processus doivent avoir été déclarés avec un ou plusieurs stéréotypes de relation. Les types de relations stéréotypées permettent d’identifier les types de relation utilisés par le processus, en les distinguant selon leur finalité.


Diagramme s

  • Stéréotypes de diagrammes
Cet écran permet de définir tous les stéréotypes qui seront ensuite affectés aux types de diagrammes.
  • Types de diagrammes stéréotypés
En phase d’exploitation, les types de diagrammes stéréotypés permettront de définir des règles portant sur l’appartenance d’entités aux diagrammes : « Règles d’entités (diagrammes) ».


Activités

  • Propriétés
Cet écran permet de définir toutes les activités du processus (indépendamment des modes de navigation qui seront déclaré ultérieurement). Les modes de navigation seront ensuite élaborés en fonction des activités et des liens entre activités.
    • Le « Nom de l’activité » est un texte libre.
    • Nombre d’ensembles d’entités : Une activité produit un ou deux ensembles d’entités. Dans le cas de deux ensembles d’entités, l’un des ensembles est déclaré en amont de l’autre. L’exemple typique est la Collaboration qui est en amont d’un ensemble de Classes.
    • Les ensembles d’entités comportent les informations suivantes :
      • Le nom de l’ensemble qui est un texte libre.
      • Le type d’entités produites qui sont contenues dans cet ensemble.
      • Dans le cas d’une activité comportant deux ensembles, le type de relation entre les deux ensembles d’entités de l’activité doit être spécifié ainsi que son orientation (par rapport au sens du déroulement du processus de développement).

  • Activités amont
Cet écran permet de spécifier de quelle manière les activités sont alimentées (leurs sources). A titre d'information, ce que l’activité produit a été déclaré au niveau de l’écran des activités.
La liste en colonne de gauche contient toutes les activités du processus (déclarées dans l’écran précédent). Il n’est pas possible de modifier cette liste. Si une activité doit être ajoutée ou supprimée, cette modification doit se faire dans l’écran des activités.
La partie droite de l’écran permet de déclarer les sources de chaque ensemble d’activités.
    • Si l’activité comprend un seul ensemble d’entités, une seule liste sera présentée pour être saisie.
    • Si l’activité comprend deux ensembles d’entités, deux listes seront affichées. Dans ce cas, le sens de la relation entre les deux ensembles sera affiché (entre les deux listes). L’orientation mentionnée entre les deux ensembles est en lecture seule. Elle est modifiable dans l’écran de déclaration des activités.
La saisie dans les ensembles se fait de la manière suivante :
    • Pour ajouter une source : Faire un click droit dans la liste en dehors de toute ligne existante, dans le menu popup qui s’affiche, cliquer sur « Ajouter ».
    • Pour modifier une source figurant dans la liste : faire un click droit sur la ligne à modifier et au menu popup, choisir « Modifier ». Une autre possibilité consiste à effectuer un double-click sur la ligne à modifier. Une boîte de dialogue apparait avec les valeurs de la ligne. Il est alors possible de les modifier.
    • Pour supprimer une source de la liste : faire un click-droit sur la ligne à supprimer. Le système vous demande alors de confirmer la suppression.


Règles du processus

Les règles du processus permettent d'auditer un modèle afin de contrôler qu’il respecte la méthodologie que vous avez définie.

Il existe quatre types de règles d’audit de processus qui sont : Entités (Propriétés) ; Entités (Relations) ; Entités (Diagrammes) ; Relations.

Pour chaque type de règle, le nom de la règle doit être saisi, ainsi que l’existence éventuelle d’un lien avec une activité. Si un lien a été saisi, le nom de l’activité liée doit être renseigné. Ce lien avec l’activité permettra ensuite, en phase d’exploitation, de filtrer le résultat de l’audit du modèle par type d’activité.
Les types de règles :
  • Entités (Propriétés) :
Ce type de règle permettra de vérifier que certains types d’entités possédent une note textuelle ou un fichier lié (avec l’endroit où ce fichier est stocké) ou un Linked document.

La règle est spécifiée sous la forme :

Toutes les entités du type %TypeDEntitéStéréotypé
doivent avoir un(e) Fichier lié | Description textuelle | Linked document
de format %Chemin + %Préfixe + %NomEntité + %Suffixe + %Extension (1)

(1) Le format n’est demandé que dans le cas d’un fichier lié.

  • Entités (Relations) :
Ce type de règle permet de vérifier que certains types d’entités doivent être liés à d’autres types d’entités, par un certain type de relation, en respectant certaines cardinalités.

La règle est spécifiée sous la forme :
Toutes les entités du type %TypeDEntitéStéréotypé doivent être liées à
au moins une | une unique | au plus une
Entité du type | Entité parmi les types | Entité dans uniquement l’un des types
Cas « Entité du type » :
%TypeDEntitéStéréotypé2, relié par une relation du type %TypeDeRelationStéréotypé
Cas « Entité parmi les types » ou « Entité dans uniquement l’un des types » :
n x (%TypeDEntitéStéréotypé2, relié par une relation du type %TypeDeRelationStéréotypé)

  • Entités (Diagrammes) :
Ce type de règle permet de vérifier l’appartenance des entités aux diagrammes. Par exemple : « Toutes les entités du type UseCase – « Besoin » doivent figurer dans au moins un diagramme de cas d’utilisation.
La règle est spécifiée sous la forme :
Toutes les entités du type %TypeDEntitéStéréotypé
Doivent figurer dans au moins un | un unique | au plus un
Diagramme du type %TypeDeDiagrammeStéréotypé

  • Relations :
Ce type de règle permet de vérifier que les types de relations relient bien les types d’entités voulus. Par exemple, que la relation d’association « Collaboration d’analyse » relie bien des entités Collaborations d’analyse à des Classes d’analyse.

La règle est spécifiée sous la forme :

Toutes les relations du type %TypeDeRelationStéréotypée
Doivent relier
Un type d’entité 1 %TypeDEntitéStéréotypé
A un type d’entité 2 %TypeDEntitéStéréotypé


Navigation dans le modèle

  • Modes de navigation
  • Ecrans de navigation


Modes de navigation

Cet écran permet de spécifier le nom des modes de navigation.

Ce nom est un texte libre.


Ecrans de navigation

Cet écran permet de spécifier l’interface utilisation qui permettra de naviguer dans le modèle de multiples façons.

En entête de l’écran, vous pouvez sélectionner le mode de navigation que vous voulez modifier. Les modifications se font dans le cadre principal de l'écran.
L’entête comprend un bouton « Vider » permettant de supprimer toutes les caractéritiques du mode de navigation sélectionné.

Partie principale :

C’est dans cette zone que vous déclarez toutes les activités de votre processus qui interviennent dans le mode de navigation sélectionné en entête.

Chaque colonne représente une ou plusieurs activités. Dans le cas où la colonne contient plusieurs activités (Groupe d’activités) , celles-ci sont des activités qui peuvent se dérouler en parallèle, par exemple les activités de conception sur différentes plateformes. Toutefois, il est également possible de placer ces activités « parallèles » dans des colonnes successives.

Chaque rectangle désigne une activité avec un titre (modifiable) et l’ensemble de type d’entités ou les deux ensembles de type d’entités que cette activité contient. Dans le cas de deux ensembles d’entités, une flèche précise le sens (amont-aval) de la relation entre les deux ensembles d’entités.
En cliquant sur un ensemble de type d’entités, le système met en surbrillance les ensembles de type d’entités des activités qui sont les sources de cet ensemble cliqué. Remarque : Quand la source fait partie de la même activité, elle n'est pas mise en surbrillance.
Création et modifications :
    • Ajouter une activité :
Vous pouvez ajouter une activité à la fin ou l’insérer entre deux colonnes existantes.
      • à la fin :
Vous pouvez soit :
        • faire un click droit sur le fond de la zone de saisie et sélectionner « Ajouter une activité » ou « Ajouter un groupe d’activité »,
        • faire un click droit sur une activité et cliquer sur « Ajouter à la fin du processus ».
      • Insérer :
Vous devez faire un click droit sur l’activité où vous voulez placer la nouvelle activité et sélectionner « Insérer dans le processus ».

    • Supprimer une activité
Vous devez faire un click droit sur l’activité que vous voulez supprimer et sélectionner « Supprimer ».

    • Modifier une activité :
Vous pouvez soit :
      • Maintenir la touche « Ctrl » et faire un click sur l’activité à modifier
      • Faire un click droit sur l’activité à modifier et sélectionner « Modifier »
Une boîte de dialogue s’affiche alors pour effectuer les modifications.

    • Transformer une colonne d’activité unique en colonne de « Groupe d'activités » :
Vous devez faire un click droit sur l’activité de la colonne à transformer en groupe d’activités et sélectionner « Transformer en Groupe ».

    • Diviser l'ensemble des colonnes en deux parties pour faciliter le redimensionnement des colonnes en exploitation, en les regroupant en deux parties :
Vous devez effectuer un click droit sur la colonne qui devra être la première colonne de la partie droite en exploitation et sélectionnez « Première Activité de la partie droite ». La couleur des titres des colonnes de la partie droite est alors changée.

    • Ajouter une activité dans un groupe d’activités :
La colonne doit être une colonne de Groupe d’activités. Si ce n’est pas le cas, vous devez commencer par effectuer cette transformation. Vous devez faire un click droit sur l'une des activités de la colonne dans laquelle vous voulez ajouter une activité et sélectionner « Ajouter Activité dans le Groupe ». La boîte de dialogue de saisie d’activité s’affiche alors pour saisir les propriétés de la nouvelle activité du groupe.

    • Descendre une activité dans un groupe d’activités :
Vous devez effectuer un click droit sur l’activité (du groupe d’activité) que vous voulez descendre et sélectionner « Descendre l’Activité ».

    • Monter une activité dans un groupe d’activités :
Vous devez effectuer un click droit sur l’activité (du groupe d’activité) que vous voulez monter et sélectionner « Monter l’Activité ».

    • Modifier le nom du groupe d’activités :
Vous devez effectuer un click droit sur le libellé placé en entête de colonne et sélectionner « Modifier ». Une boîte de dialogue s’affiche alors et vous permet de modifier le nom du groupe d’activités.

    • Transformer un groupe d’activités en activité (unique) :
Pour pouvoir transformer une colonne de groupe d’activités en colonne d’activité unique, il est nécessaire que la colonne concernée ne contienne qu’une seule activité. Si plusieurs activités figurent dans la colonne, il est nécessaire de supprimer toutes celles que vous ne voulez pas conserver avant d’effectuer la transformation.
Vous devez soit :
      • effectuer un click droit sur le libellé du groupe d’activité (en titre de colonne) et sélectionner « Transformer en Activité ».
      • effectuer un click droit sur l’activité (unique) de la colonne de groupe d’activités et sélectionner « Transformer en Activité ».

    • Boîte de dialogue de Saisie des propriétés d’une activité :
      • Zones actives :
La boîte de dialogue présente des zones actives et d’autres zones inactives en fonction du contexte de l’activité à saisir ou à modifier.

  • Si la saisie concerne un groupe d’activités, la partie haute sera accessible pour permettre de saisir le nom du groupe.
  • Si la saisie concerne une activité comportant un seul ensemble, la zone basse nommée « Ensemble 2 de l’activité » sera visible mais inactive.
  • Si la saisie concerne une activité comportant deux ensembles, la zone basse nommée « Ensemble 2 de l’activité » sera active.

      • Saisie des propriétés de l’activité :
  • Le nom de l’activité est un texte libre. En utilisant le bouton « => Nom », vous pouvez remplir le nom de l’activité par le nom de l'activité qui lui est affectée.
  • Vous pouvez provisoirement laisser le module sans activité affectée, mais pour valider le processus, vous devrez affecter une activité au module de consultation. Quand vous cochez « Affecter une Activité », la liste déroulante « Choix de l’Activité » vous présente toutes les activités possibles en fonction du processus que vous avez déclaré dans les écrans « Activités - Propriétés » et « Activités - Activités amont ». Un seul ou deux ensembles seront activés en fonction de l’activité sélectionnée.

    • Saisie des propriétés des ensembles :
Le but de cette zone de saisie est de sélectionner les sources de l'activité en amont qui alimentent cet ensemble. Toutes les données sont en lecture sauf la liste des sources qui permet de visualiser les propriétés de la source et être sélectionnée.


Imprimer le processus

Imprimer un processus

Pour imprimer les informations du processus, il est nécessaire, au choix, de :
  • cliquer sur le menu « Fichier » et de sélectionner « Imprimer le processus … ».
  • cliquer sur le bouton « Imprimer le processus … » dans la barre d’icônes.
Une boîte de dialogue s’affiche. Vous pouvez sélectionner les informations que vous souhaitez imprimer. Toutes les éditions sont concaténées pour former un document unique.

Si au moment de la demande d’impression, vous êtes dans l’un des écrans de spécification du processus, cette édition sera déjà cochée à l’ouverture de la boîte de dialogue.


Enregistrer le processus

Pour enregistrer le processus, il est nécessaire, au choix, de :

  • cliquer sur le menu « Fichier » et sélectionner « Enregistrer ».
  • cliquer sur le bouton « Enregistrer » dans la barre d’icônes.


Enregistrer une copie du processus

Vous devez ouvrir le menu « Fichier » et sélectionner « Enregistrer sous … ».

Une boîte de dialogue est alors ouverte pour saisir le nom du fichier.


Valider le processus

Pour pouvoir passer en exploitation il est nécessaire de valider le processus. Après cette validation, vous pourrez utiliser le processus sur un modèle UML.

Pour effectuer cette validation, vous pouvez, au choix :
  • Cliquer sur le menu « Processus », puis cliquer sur « Valider le processus ».
  • Cliquer sur le bouton « Valider le processus » dans la barre d’icônes.
Si le processus présente des anomalies, celles-ci seront affichées. Il sera alors nécessaire de corriger le processus avant de redemander sa validation.


Modifier le processus

Quand un processus est validé, il est impossible de le modifier. Toutefois, les écrans de spécification présente les informations de ce processus en lecture seule.

Pour pouvoir revenir en arrière et modifier un processus, il faut afficher le menu « Processus » et sélectionner le sous-menu « Modifier le processus ».

Il sera possible de passer à nouveau en exploitation quand le processus sera à nouveau validé.


Exploitation

Onglet Exploitation

Pour pouvoir charger un modèle, il faut que le processus soit chargé et qu’il soit validé.

A partir de ce moment là, le chargement d'un modèle sera activable.


Charger un modèle

Avant de demander le chargement d’un modèle, il est nécessaire de lancer Enterprise Architect © et ouvrir dans Enterprise Architect le modèle que vous voulez utiliser avec ApplicationIQ.

Pour charger un modèle, il faut :
  • Cliquer sur le bouton « Charger un modèle » qui se trouve dans la barre d’icônes.
  • Dans la boîte de dialogue qui s’affiche, sélectionner une instance d’Enterprise Architect actuellement en cours d’exécution et l’un des modèles qui sont ouverts dans cette instance.
  • Après la validation de cette saisie, le modèle se charge et ApplicationIQ est en « Exploitation ».


Décharger un modèle

Pour décharger le modèle en cours, vous devez ouvrir le menu « Fichier » et sélectionner « Décharger le modèle ».

Suite à cette action, il est possible de charger un autre modèle.

Remarque : Le processus en cours reste présent en mémoire.


Auditer un modèle

Pour lancer un audit de modèle, vous devez soit :

  • Cliquer sur le bouton « Lancer un audit du modèle ».
  • Ouvrir le menu « Processus » et sélectionner « Lancer un audit du modèle ».

Le résultat de l’audit est affiché dans la partie basse de l’écran ("Liste d’erreurs / Règles").

Toutes les règles qui ne sont pas respectées sont affichées dans la liste avec les informations du modèle concernées par l’anomalie.


Consulter la liste des erreurs d'audit

La liste des erreurs affiche toutes les erreurs correspondant aux critères activés.

Le nombre d’erreurs affiché sous la liste est dépendant du filtre actif.

Un lien sous la liste permet de copier son contenu dans le presse papier au format CSV.

Les critères (« Vue par ») portent au choix sur les « Types de règles » ou « Les activités ».

  • Vue par « Type de règle » :
  • Les quatre types de règles sont affichés : Entités (Propriétés), Entités (Relations), Entités (Diagrammes), Relations.
  • Le fait d’activer ou désactiver un type de règle modifie la liste en filtrant les anomalies selon ces nouveaux critères.
  • Le bouton « Tous » permet d’activer tous les types de règle en même temps.
  • Vue par « Activité » :
  • Les activités que vous avez déclarées en spécification du processus sont affichées également comme filtre.
  • Le fait d’activer ou désactiver une activité modifie la liste en filtrant les anomalies selon ce critère.
  • Le bouton « Tous » permet d’activer toutes les activités en même temps.
  • Le filtre « Non lié » permet d’afficher les anomalies liées à une règle qui n’a pas été affectée à une activité pendant la phase de spécification des règles.


Généralités

Naviguer dans un modèle

(Informations communes aux deux « types » de navigation)

La partie haute de l’écran de navigation comprend trois informations :

  • Une liste déroulante permettant de choisir le mode de navigation voulu parmi ceux qui ont été déclarés en spécification. Il est possible de changer à tout moment de mode de navigation.
  • La sélection du « Type de navigation » souhaité parmi « Standard » et « Complétude ».
  • Un champ mentionnant le package UML et son chemin en rapport avec la dernière entité sélectionnée.


Type de navigation "Standard"

Ce type de navigation permet de naviguer d’une manière « classique » dans votre modèle et passer d’activité en activité en ayant les entités comme fil conducteur.

Vous devez commencer par sélectionner l’activité qui servira de départ à votre navigation.

Si cette activité est :

  • la première du processus, vous effectuerez naturellement un parcours vers l’avant (de l’amont vers l’aval).
  • la dernière du processus, vous effectuerez un parcours vers l’arrière (de l’aval vers l’amont), en mode « rétro ».
  • une activité intermédiaire (ni la première, ni la dernière du processus), vous effectuerez un parcours à la fois vers l’arrière et vers l’avant à partir des entités de cette activité sélectionnée.
Remarque : Quand vous sélectionnez une activité intermédiaire qui comporte deux ensembles d’entités, il vous est demandé quel est l’ensemble que vous voulez remplir parmi les deux qui sont possibles.

Une activité comporte une ou deux listes d’entités et une liste de diagrammes.

Quand vous sélectionnez une ou plusieurs entités d’une liste :

  • les listes d’entités immédiatement suivantes (dans l’ordre des déclarations du mode de navigation du processus) sont remplies,
  • la liste des diagrammes est mise à jour en affichant tous les diagrammes qui contiennent les entités sélectionnées dans cette activité.

Avec ce mode de navigation, vous pouvez savoir par exemple :

  • à quel stade en est l’avancement d’un projet de réalisation,
  • quel est l’impact de changements sur une fonctionnalité
  • quel est l’impact de changements sur une classe de conception
  • est-ce que toutes les classes fondamentales sont bien suivies de classes de tests de non régression automatiques ?
  • est ce que le projet de rétro-documentation détaille de manière éloquente les aspects importants du logiciel ?
  • est-ce que la réorganisation du projet relie bien tous les éléments de documentation à des classes d’implémentation en passant par les cas d’utilisation et vice-versa ?
  • quelle est le niveau d’avancement d'un projet de rétro-ingénierie ?
  • …


Type de navigation "Complétude"

Ce type de navigation permet d’interroger le modèle sur la question de sa complétude, en partant du principe que toute entité d’une activité doit être reliée à au moins une entité d’une activité aval qui elle-même sera reliée à une autre entité d’une activité plus en aval et ainsi de suite, pour arriver à une entité de la dernière activité.

Par ce principe, on considère qu’un modèle est complet si chaque entité est reliée directement ou indirectement à une entité de la dernière activité.

Toute entité qui ne respecte pas ce principe montre que le modèle est en état d'incomplétude.

  • Incomplétude :
Dans ce type de navigation, les entités qui sont affichées dans les listes sont les entités qui mettent le modèle en état d' « incomplétude ». Elles possèdent donc sur leur parcours vers l’activité finale des entités qui n’ont pas d’entité dans l’activité suivante.

Attention : Il est à noter qu’il suffit à une entité d’être reliée à une unique entité de l’activité suivante pour qu’elle ne soit pas détectée comme en « incomplétude ». Ce qui n’est pas forcément exact. Un contrôle est donc nécessaire. La lecture des documents et l’affichage des diagrammes permettent d’effectuer la vérification. Par contre, si une entité n’est reliée à aucune entité dans une activité suivante, elle met de manière certaine le modèle en état d' « incomplétude ».

  • Nœud « Feuille » dans le parcours :
Certaines entités sont en surbrillance. Ce sont les entités qui ne sont reliées à aucune autre entité dans la suite du processus.
  • Sélection d’une entité :
En sélectionnant une entité, toutes les entités suivantes (vers l’avant ou vers l’arrière) qui sont reliées à cette entité de manière directe ou indirecte sont mises en évidence.
Comme pour le type de navigation « Standard », la sélection d’une entité entraine l’affichage de la liste des diagrammes dans lesquels elle apparait et le nom du package (avec le chemin) qui la contient dans le modèle UML.
  • Avec ce mode de navigation, vous pouvez :
    • Visualiser en un click le niveau de complétude d’un projet, que ce projet soit un projet de réalisation, de rétro-ingénierie, …
    • Définir les entités qui sont à réaliser en priorité.
    • Visualiser immédiatement les manques dans le modèle sans avoir à parcourir toutes les branches entité par entité, d’activité en activité.
    • …


Outils

On appelle « Stéréotypage », l'ensemble des stéréotypes qui sont attribués à une entité ou une relation.

Les deux outils décrits ci-après permettent très facilement d’affecter des stéréotypes aux entités et aux relations de votre modèle d’une manière extrêmement efficace.

Sans ces outils, le stéréotypage peut être très fastidieux, que ce soit en rétro-ingénierie, en processus MDA ou autres …. car il faut pouvoir appliquer des stéréotypes à toutes les entités et toutes les relations.

ApplicationIQ permet d’affecter des stéréotypes à des ensembles d'entités ou de relations que vous aurez définis.

Il est raisonnable de dire que faire du MDA sans posséder un outils de stéréotypage en volume, comme ceux de ApplicationIQ, est utopique étant donné la charge et les difficultés de gestion du stéréotypage qu’il nécessite.

ApplicationIQ permet de cibler un ensemble d'objets (entités ou relations) et d'affecter en un click des stéréotypes à tous les objets (entités ou relations) de cet ensemble.

Remarque : pour visualiser le résultat de vos modifications dans Enterprise Architect©, il est nécessaire de recharger ou rafraichir le diagramme dans Enterprise Architect si celui-ci est déjà ouvert.


Modification de Stéréotypage d'entités

Cet outil permet de visualiser le stéréotypage des entités … et de modifier ce stéréotypage en supprimant certains stéréotypes et en en ajoutant d’autres.

  • Comme première action, vous devez charger les données du modèle en cliquant sur le bouton « Charger les données ».
Suite à cette action, l’arbre du modèle (avec ses stéréotypes affectés) et la zone de liste des stéréotypes applicables sont remplis.
  • Vous pouvez parcourir l’arborescence du modèle et sélectionner le nœud sur lequel ou à partir duquel vous allez appliquer les stéréotypes désignés.
Si le nœud sélectionné est une entité (et non un package), les stéréotypes affectés à cette entité sont affichés dans la zone « Stéréotype ».
  • La zone « Stéréotype » présente tous les stéréotypes qui ont été définis dans la partie « Spécification » du processus.
Vous pouvez modifier les stéréotypes qui sont désignés : supprimer un stéréotype en décochant, ajouter des stéréotypes en cochant.
  • La zone « Modifications » permet de définir de quelle manière le stéréotypage de la zone « Stéréotype » sera appliqué.
    • Cible : permet de choisir si le stéréotypage sera appliqué à un "élément unique" (celui qui est sélectionné dans la zone « Modèle ») ou "Niveau inférieur uniquement" (toutes les entités qui sont placées en dessous de l’entité sélectionnée) ou "Récursif" (l’entités sélectionnée ainsi que toutes les entités placées directement ou indirectement en dessous).
    • Tous les types : lorsque cette case est cochée, aucune distinction de type n’est effectuée dans l’application du stéréotypage.
    • Type d’élément : cette liste contient la liste de tous les types d’éléments qui existent dans ApplicationIQ. La sélection dans cette liste est possible uniquement si la case « Tous les types » n’a pas été cochée. Dans ce cas, le stéréotypage sera appliqué uniquement sur les entités du type sélectionné.
    • Le bouton « Appliquer » permet successivement de :
      • supprimer le stéréotypage qui existait avant de cliquer,
      • affecter le nouveau stéréotypage.
    • Le bouton "Ajouter" permet d’ajouter le stéréotypage demandé à ce qui existait avant de cliquer. Il n’y a pas de suppression du stéréotypage précédent.
Après avoir effectué la modification, la zone « Modèle » est mise à jour et les entités du modèle UML chargé dans Enterprise-Architect sont modifiés avec les nouveaux stéréotypes.


Modification de Stéréotypage de relation

L’outil de modification des stéréotypes de relations permet de sélectionner des relations par les propriétés de leurs extrémités et par un type de relation. Ceci permet de créer un ensemble de relations. Il est possible ensuite d’affecter à chacune de ces relations un ou plusieurs stéréotypes parmi ceux existant pour ce type de relation dans la méthodologie qui a été spécifiée.

L’utilisation de cet outil se fait donc en trois étapes :

1. Sélection des relations sur lesquelles ont veux opérer :

Important : Il est à noter que l’ensemble des relations (liste basse de l’écran) est actualisé quand les trois informations sont saisies. Si les critères n’aboutissent à aucune relation dans le modèle, la liste reste vide.
1.1. Sélection des entités de l’extrémité 1 :
Vous devez sélectionner un type d’élément dans la liste. La liste des stéréotypes est alors mise à jour. Vous devez ensuite sélectionner un stéréotype parmi ceux qui sont proposés. L’arbre du modèle est alors rempli selon ce filtre.
Vous pouvez aussi sélectionner un package.
1.2. Sélection des entités de l’extrémité 2 :
La procédure est la même que pour l’extrémité 1 et permet de définir l’ensemble des entités pour l’extrémité 2.
1.3. Sélection du type de relation :
Vous devez sélectionner un type de relation entre l’extrémité 1 et l’extrémité 2.
Quand les trois critères aboutissent à un ensemble de relations non vide, deux listes sont mises à jour :
        • La liste des relations en bas d’écran. Cette liste contient toutes les relations qui correspondent aux trois critères de sélection.
        • La liste des « Stéréotypages actuels ». Cette liste contient un stéréotypage par ligne, un stéréotypage est un ensemble de stéréotypes (appliqués à une entité ou une relation). Cette liste est remplie à partir du contenu de la liste des relations et présente tous les stéréotypages existants.
Par exemple, si vous avez deux relations R1 et R2 avec les stéréotypages suivants :
          • R1 : StéréotypeA, StéréotypeB
          • R2 : StéréotypeB
La liste des stéréotypages mentionnée sera :
          • StéréotypeA, StéréotypeB
          • StéréotypeB
Si vous changez les critères de sélection et que vous avez deux nouvelles relations :
          • R3 : StéréotypeA
          • R4 : StéréotypeB
Vous aurez alors la liste des stéréotypages actuels suivante :
          • StéréotypeA, (pour R3)
          • StéréotypeB, (pour R2 et R4)
          • StéréotypeA, StéréotypeB (pour R1)

2. Sélection des stéréotypes que vous voulez appliquer ou ajouter
La zone « Appliquer, ajouter … » contient la liste des stéréotypes utilisables avec le type de relation sélectionné en 1.3 et qui ont été déclaré en mode « Spécification ».
Dans cette liste, vous devez sélectionner les stéréotypes que vous voulez appliquer ou ajouter (selon le bouton) à toutes les relations figurant dans la liste des relations (bas d’écran).
3. Effectuer la modification en cliquant sur « Appliquer » ou « Ajouter ».

Le click sur « Appliquer » permet de supprimer les stéréotypes actuels des relations sélectionnées et apparaissant dans la liste en bas d’écran, puis à affecter les stéréotypes sélectionnés dans la liste de cette même zone.

Le click sur « Ajouter » permet d’ajouter les stéréotypes de la liste aux relations figurant dans la liste des relations (sans suppression préalable).